Teach git var about GIT_PAGER
[git/git.git] / git-sh-setup.sh
CommitLineData
b33e9666
LT
1#!/bin/sh
2#
ae2b0f15
JH
3# This is included in commands that either have to be run from the toplevel
4# of the repository, or with GIT_DIR environment variable properly.
5# If the GIT_DIR does not look like the right correct git-repository,
6# it dies.
b33e9666 7
365527ad 8# Having this variable in your environment would break scripts because
e598c517 9# you would cause "cd" to be taken to unexpected places. If you
365527ad
JH
10# like CDPATH, define it for your interactive shell sessions without
11# exporting it.
12unset CDPATH
13
61dbb3c4
JH
14git_broken_path_fix () {
15 case ":$PATH:" in
16 *:$1:*) : ok ;;
17 *)
18 PATH=$(
19 SANE_TOOL_PATH="$1"
20 IFS=: path= sep=
21 set x $PATH
22 shift
23 for elem
24 do
25 case "$SANE_TOOL_PATH:$elem" in
26 (?*:/bin | ?*:/usr/bin)
27 path="$path$sep$SANE_TOOL_PATH"
28 sep=:
29 SANE_TOOL_PATH=
30 esac
31 path="$path$sep$elem"
32 sep=:
33 done
34 echo "$path"
35 )
36 ;;
37 esac
38}
39
40# @@BROKEN_PATH_FIX@@
0e0aea5a 41
b33e9666 42die() {
8098a178 43 echo >&2 "$@"
b33e9666
LT
44 exit 1
45}
46
e064c170
SB
47GIT_QUIET=
48
49say () {
50 if test -z "$GIT_QUIET"
51 then
52 printf '%s\n' "$*"
53 fi
54}
55
bac199b7
PH
56if test -n "$OPTIONS_SPEC"; then
57 usage() {
5d292756
JH
58 "$0" -h
59 exit 1
bac199b7
PH
60 }
61
e817e3e8
PH
62 parseopt_extra=
63 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
64 parseopt_extra="--keep-dashdash"
65
66 eval "$(
cbea86fd 67 echo "$OPTIONS_SPEC" |
e817e3e8
PH
68 git rev-parse --parseopt $parseopt_extra -- "$@" ||
69 echo exit $?
70 )"
bac199b7 71else
1b1dd23f 72 dashless=$(basename "$0" | sed -e 's/-/ /')
bac199b7 73 usage() {
1b1dd23f 74 die "Usage: $dashless $USAGE"
bac199b7
PH
75 }
76
77 if [ -z "$LONG_USAGE" ]
78 then
1b1dd23f 79 LONG_USAGE="Usage: $dashless $USAGE"
bac199b7 80 else
1b1dd23f 81 LONG_USAGE="Usage: $dashless $USAGE
bac199b7
PH
82
83$LONG_USAGE"
84 fi
85
86 case "$1" in
87 -h|--h|--he|--hel|--help)
88 echo "$LONG_USAGE"
89 exit
90 esac
91fi
d025524d 92
f9474132
SP
93set_reflog_action() {
94 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
95 then
96 GIT_REFLOG_ACTION="$*"
97 export GIT_REFLOG_ACTION
98 fi
99}
100
ef0c2abf 101git_editor() {
08874658
DK
102 : "${GIT_EDITOR:=$(git config core.editor)}"
103 : "${GIT_EDITOR:=${VISUAL:-${EDITOR}}}"
ef0c2abf
AR
104 case "$GIT_EDITOR,$TERM" in
105 ,dumb)
106 echo >&2 "No editor specified in GIT_EDITOR, core.editor, VISUAL,"
107 echo >&2 "or EDITOR. Tried to fall back to vi but terminal is dumb."
108 echo >&2 "Please set one of these variables to an appropriate"
109 echo >&2 "editor or run $0 with options that will not cause an"
110 echo >&2 "editor to be invoked (e.g., -m or -F for git-commit)."
111 exit 1
112 ;;
113 esac
08874658 114 eval "${GIT_EDITOR:=vi}" '"$@"'
ef0c2abf
AR
115}
116
4b441f47 117is_bare_repository () {
5be60078 118 git rev-parse --is-bare-repository
4b441f47
JH
119}
120
9fde9401 121cd_to_toplevel () {
5be60078 122 cdup=$(git rev-parse --show-cdup)
9fde9401
JH
123 if test ! -z "$cdup"
124 then
2c3c395e
MC
125 # The "-P" option says to follow "physical" directory
126 # structure instead of following symbolic links. When cdup is
127 # "../", this means following the ".." entry in the current
128 # directory instead textually removing a symlink path element
129 # from the PWD shell variable. The "-P" behavior is more
130 # consistent with the C-style chdir used by most of Git.
131 cd -P "$cdup" || {
132 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
9fde9401
JH
133 exit 1
134 }
135 fi
136}
137
7eff28a9 138require_work_tree () {
e90fdc39 139 test $(git rev-parse --is-inside-work-tree) = true ||
7eff28a9
SP
140 die "fatal: $0 cannot be used without a working tree."
141}
142
0cae2346
JS
143get_author_ident_from_commit () {
144 pick_author_script='
145 /^author /{
146 s/'\''/'\''\\'\'\''/g
147 h
148 s/^author \([^<]*\) <[^>]*> .*$/\1/
149 s/'\''/'\''\'\'\''/g
150 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
151
152 g
153 s/^author [^<]* <\([^>]*\)> .*$/\1/
154 s/'\''/'\''\'\'\''/g
155 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
156
157 g
158 s/^author [^<]* <[^>]*> \(.*\)$/\1/
159 s/'\''/'\''\'\'\''/g
160 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
161
162 q
163 }
164 '
165 encoding=$(git config i18n.commitencoding || echo UTF-8)
077b725f 166 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
0cae2346
JS
167 LANG=C LC_ALL=C sed -ne "$pick_author_script"
168}
169
22c90717
JH
170# Make sure we are in a valid repository of a vintage we understand,
171# if we require to be in a git repository.
70087cdb 172if test -z "$NONGIT_OK"
d025524d 173then
4d6d6d2d 174 GIT_DIR=$(git rev-parse --git-dir) || exit
22c90717
JH
175 if [ -z "$SUBDIRECTORY_OK" ]
176 then
22c90717
JH
177 test -z "$(git rev-parse --show-cdup)" || {
178 exit=$?
179 echo >&2 "You need to run this command from the toplevel of the working tree."
180 exit $exit
181 }
22c90717
JH
182 fi
183 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
184 echo >&2 "Unable to determine absolute path of git directory"
185 exit 1
b2bc9a30 186 }
22c90717 187 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
d025524d 188fi
87bddba9
JS
189
190# Fix some commands on Windows
191case $(uname -s) in
192*MINGW*)
193 # Windows has its own (incompatible) sort and find
194 sort () {
195 /usr/bin/sort "$@"
196 }
197 find () {
198 /usr/bin/find "$@"
199 }
200 ;;
201esac